################################
##BASIC OPERATIONS

##generate HTML page to navigate amongst help files
help.start( )

##search based on a keyword or topic to find
##functions dealing with given topic
help.search(apropos = "generalized linear models")

##search help file on a given function
?mean
?glm

##search help on R archives on web
RSiteSearch("glm")



##search R archives on web
RSiteSearch("creating eps file")

##create object with single value
y <- 15.3
y
Y #sensitive to upper and lower case





##enter values and assign them to object
y <- c(1, 12, 31, 14, 50, 22, 13, 14, 25, 26)
##y has been replaced with new values
         



##select sixth observation of y variable
y[6]
y




##create variable with value repeated 20 times
new_y <- rep(x = 5, times = 20)
new_z <- rep(x = c("new", "old"), times = 3)






##create variable with sequence from 1 to 10 with step of 1
y2 <- seq(from = 1, to = 10, by = 1)
y3 <- seq(from = 10, to = 1, by = -2)


##check characteristics of object
class(y3)
is.numeric(y3)
class(new_z)
is.numeric(new_z)
is.character(new_z)

length(y)




##arithmetic operators
30+10
2*5
15/3
y+y2
2-y2


sum(y)
prod(y)
2^3
round(123.3453, digits = 2)
round(123.3453, digits = 0)

range(y)




##compute first derivative of dx2/dx
D(expression(x^2),"x")
##compute first derivative of d(x + x^2 + 2z^3) /dz
D(expression(x+(x^2)+(2*z^3)), "z")

##compute integral
integrate(dnorm, -1.96, 1.96) #area under the curve of standard normal distribution from -1.96 to 1.96




##create matrix
mat<-matrix(data = c(1:9), nrow = 3, ncol = 3)
mat
mat<-matrix(data = c(1:9), nrow = 3, ncol = 3, byrow = TRUE)
mat

##check characteristics
class(mat)
is.numeric(mat)
is.vector(mat)
length(mat)
dim(mat)
ncol(mat)
nrow(mat)


##get diagonal of matrix
diag(mat)



##select elements of matrix
mat[1,2]
mat[3,1]
mat[,1]
mat[2,]
mat[1:2,1]
mat[c(1,3),3]

##compute transpose of matrix
mat_transpose <- t(mat)


##compute matrix inverse
mat1 <- matrix(data = y[1:9], nrow = 3, ncol = 3)
mat1_inv <- solve(mat1)

##definition of matrix inverese
def_inv <- mat1%*%mat1_inv
round(def_inv, digits = 4)

##multiply matrix by vector
vector <- c(2, 4, 5)
mat%*%vector

##functions to compute means and sums of rows or columns
colSums(mat)
colMeans(mat)
rowSums(mat)
rowMeans(mat)



##data frames
##create variables 
Time <- c(1.2, 3.4, 2.1, 5.5)
Mass <- c(2.5, 4.2, 5.6, 3.4)
Sex <- c("male", "female", "male", "female")
##put them in data frame
dat <- data.frame(Time, Mass, Sex)

##one could have created the data frame in a single command
dat1 <- data.frame(Time = c(1.2, 3.4, 2.1, 5.5),
                   Mass = c(2.5, 4.2, 5.6, 3.4),
                   Sex = c("male", "female", "male", "female"))

##compare both
all.equal(dat, dat1)

#check characteristics
class(dat)
length(dat)
dim(dat)

##structure of data frame
str(dat)
##summary of data frame
summary(dat)
##first observations
head(jeu)
##last observations
tail(jeu)



data_set <- data.frame(Speed=c(25, 40, 70, 100), Type=c("car", "truck", "car", "truck"))
Speed
data_set$Type
data_set[,2]
attach(data_set) #usually bad idea to attach, better to work with $ operator to avoid nasty suprises

data_set$log_Speed <- log(data_set$Speed)
log_Speed
data_set
detach(data_set)
data_set$log_Speed
attach(data_set$log_Speed)
log_Speed

                        

##import data frame from file
worms <- read.table(file ="c:\\Documents and Settings\\mazerolm\\Worms.txt",
                    header = TRUE) #must use either \\ or / but not \

##import without argument header=TRUE and see that it wreaks havoc
worms_b <- read.table(file = "c:\\Documents and Settings\\mazerolm\\Worms.txt")

##other strategy: import with file.choose() - this stems a little window to click to file
worms_c <- read.table(file = file.choose(), header = TRUE)

##other strategy:  set a working directory at the beginning of the R session to tell R where files are stored
setwd(dir = "c:\\Documents and Settings\\mazerolm\\")
worms_d <- read.table(file = "Worms.txt", header = TRUE)

##check current working directory
getwd()

attach(worms)
names(worms)
summary(worms)
plot(worms)

##use indices
worms[1,]
worms[1:15,]
worms[,3]
worms[,3:5]
worms[1,3:5]


##logical tests
worms$Slope == 0
worms$Slope > 0
worms$Slope != 0
worms$Vegetation == "Grassland"

which(worms$Slope != 0)
which(worms$Vegetation == "Grassland")

##create binary variable from logical test
worms$Grassland <- ifelse(worms$Vegetation == "Grassland", 1, 0)
##create categorical variable from nested logical tests
worms$Slope_cat <- ifelse(worms$Slope >= 0 & worms$Slope < 3, "Low", ifelse(worms$Slope >= 3 & worms$Slope < 6, "Med",
ifelse(worms$Slope >= 6 & worms$Slope < 9, "High", "Very High")))


##use logical tests
worms[worms$Vegetation == "Meadow",]
worms[worms$Area > 3 & worms$Slope < 3,]
subset(x = worms, subset = worms$Area > 3 & worms$Slope < 3 )

##sort variable
order(worms$Slope) #ascending order
worms[order(worms[,1]), 1:6] #sort columns 1 - 6 by values of column 1 (i.e., site names)
rev(order(worms$Slope)) #descending order
worms[rev(order(worms[,1])), 1:6]
worms[rev(order(worms[,c(1,2)])), ]

##cross-classification
table(worms$Vegetation)
table(worms$Vegetation, worms$Damp)



##effect of treatment on pain reduction in people after 6 months of treatment and number of months of pain before getting treated
neural <- read.table("C:/Documents and Settings/mazerolm/Maz folders/Biostat cours Hiver 2007/Neural.txt",
                     header = TRUE)
neural$Reduce <- as.factor(neural$Reduce)
neural$Treatment <- as.factor(neural$Treatment)

##function to summarize the occurences according to class variable(s)
tab <- table(neural$Reduce, neural$Treatment, deparse.level = 2)
tab <- as.data.frame(tab)

##look at data sets included with R
data( )
##get UCBAadmissions data 
admissions <- as.data.frame(UCBAdmissions)
##summarize frequencies
xtabs(Freq ~ Gender + Admit, data = admissions)


##modify data format
##data set in long format - all concentration in a single column
Indometh
##restructure data set to have one column per concentration (1 line/subject)
wide <- reshape(data = Indometh, idvar = "Subject",
timevar = "time", direction = "wide")
##put it back in long format
reshape(wide, direction = "long")

##similar functions to rearrange data frames
?stack
?unstack


##save as tab-delimited file
write.table(x = neural, file = "neural.txt", row.names = FALSE, col.names = TRUE, sep = "\t")
##save as space-delimited file (single space)
write.table(x = neural, file = "neural.txt", row.names = FALSE, col.names = TRUE, sep = " ")
##save as space-delimited file (five spaces)
write.table(x = neural, file = "neural.txt", row.names = FALSE, col.names = TRUE, sep = "     ")
##save as comma-delimited file
write.table(x = neural, file = "neural.txt", row.names = FALSE, col.names = TRUE, sep = ",")




################################################################
##GRAPHICS
hist(worms$Worm.density)     #generate histogram
barplot(worms$Worm.density, xlab = "Number of observation", ylab = "Worm density",
        names.arg = c(1:20)) #generate barplot and modify x and y axis labels
boxplot(worms$Worm.density ~ worms$Vegetation)  #generate boxplot
plot(worms$Worm.density ~ worms$Area)     #generate scatter plot
qqnorm(worms$Worm.density)    #create quantile-quantile plot to assess normality
qqline(worms$Worm.density)    #add reference line to indicate pattern that should be observed if data are normal
plot(worms$Worm.density ~ worms$Area)     #generate scatter plot
abline(h = 3, v = 5, col = c("red", "blue"))
points(x = 1, y = 4, pch = "+", col = 3, cex = 1.5)
text(x = 2, y = 6, labels = "an area of the graph", col = "magenta")

##modifying graphs
plot(x = 1, y = 1, ylab = "Y axis", xlab = "X axis", cex.lab = 1.5)
mtext(side = 3, text = expression(psi[i]), line = 1, cex = 1.3)
points(x = 1, y = 1.3, pch = "o", col = 2, cex = 1.5) 
points(x = 1.2, y = 1.3, pch = "P", col = "blue", cex = 3) 


plot(x = 1, y = 1, ylab = "Y axis", xlab = "X axis", cex.lab = 1.5)
mtext(side = 3, text = expression(chi^2), line = 1, cex = 1.3)

plot(1, 1, main = expression(alpha + beta +psi[i] +theta^2 +epsilon[i]), ylab = "Y axis",
     cex.lab = 1.5, xlab = "X axis", cex.main = 2) #add indices, exponents, Greek letters
text(0.8, 1.2, labels = expression(italic(paste("This is in italics"))), cex = 1.3)    #add text at given (x,y) coordinates in italics and increase size of characters to 1.3 times normal size
text(1, 1.2, labels = expression(bold(paste("This is in bold"))), cex = 2)               #add text at given (x,y) coordinates in bold and double size of characters to 1.3 times normal size
points(1, 1.3, pch = "o", col = 2, cex = 1.5)                          #add point at given (x,y) coordinates with color = 2
points(x = 1.2, y = 1.3, pch = "P", col = "blue", cex = 3)                     #add point at given (x,y) coordinates with color = "blue"
?plot     #to see plot options
?par      #to see all graphical parameters for plots


##put several plots in same window
par(mfrow = c(2, 2))
hist(worms$Worm.density)
boxplot(worms$Worm.density)
barplot(worms$Worm.density)
plot(worms$Worm.density ~ worms$Area)

par(mfcol = c(2, 2))
hist(worms$Worm.density)
boxplot(worms$Worm.density)
barplot(worms$Worm.density)
plot(worms$Worm.density ~ worms$Area)


par(mfrow = c(2, 2))
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "A", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "B", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "C", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "D", cex = 3)

par(mfcol = c(2, 2))
plot(1, 1, ylim= c(0, 5), xlim =c(0, 5), type = "n")
text(1, 1, "A", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "B", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "C", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "D", cex = 3)

##add line and predictive equation
plot(worms$Worm.density ~ worms$Area, ylab = "Density", xlab = "Area", cex.lab = 1.3)     #generate a scatter plot
mod1 <- lm(Worm.density ~ Area, data = worms)
abline(reg = mod1)
text(x = 1.5, y = 4.5, labels = expression(paste(italic(hat(y)), " = ", beta[0], " + ", beta[1], "*Area")),
     cex = 1.5, col = "darkblue")
text(x = 1.5, y = 3, labels = expression(paste(italic(R)^2, " = 2.8%")), cex = 1.5, col = "red")


##create graphics file in pdf format
pdf(file = "C:\\Fig1.pdf")
plot(x = c(1,2), y = c(6,5))

##create graphics file in postscript format
postscript(file = "C:\\Fig1.ps")
plot(x = c(1, 2), y = c(6, 5))

##restore graphics window to default value (to view on screen)
windows()
plot(x = c(1, 2), y = c(6, 5))

#create eps file
dev.copy2eps(file = "C:\\Fig1.eps")




##############################################################
##BASIC STATISTICS
##create a random variable of 30 observations taken from a normal distribution with mean = 12 and sd = 3
var1 <- rnorm(n = 30, mean = 12, sd = 3)

##probability density function for normal distribution when x = 5 from a normal distribution with mean = 2 and sd = 3
dnorm(x = 5,mean = 2,sd = 3)

##cumulative probability that x > 1.96
1-pnorm(q = 1.96, mean = 0, sd = 1)

##quantile function (inverse of cumulative probability)
qnorm(p = 0.975, mean = 0, sd = 1)


##compute arithmetic mean
mean_var1 <- mean(var1)

##compute standard deviation
sd_var1 <- sd(var1)

#median
median(var1)

#quantile
quantile(var1)

#rank
rank(var1)

#compute standard error of the mean
SE_var1 <- sd(var1)/sqrt(length(var1))


################################
##FUNCTIONS
##function to compute standard error of the mean
SE_function <- function(x) {
n_x <- length(x)
sd_x <- sd(x)
sd_x/sqrt(n_x)
}

SE_function(x = var1)

##square root of value
sq.root <- function(value) {
value^(1/2)
}
sq.root(value = 4)
sq.root(329)
##compare with actual R function in base package
sqrt(4)
sqrt(329)

##root x of variable
root_x <- function(value, level) {
value^(1/level)
}
root_x(value = 8, level = 3)

##root x of variable with default
root_x <- function(value, level = 2) {
value^(1/level)
}
root_x(16)
root_x(16, 2)

##extract sum, min, max
sum_max_min <- function(variable){
the_sum <- sum(variable)
the_min <- min(variable)
the_max <- max(variable)
list("Sum_of_observations" = the_sum, "Minimum_value" = the_min, "Maximum_value" = the_max)
}
x <- rnorm(10)
sum_max_min(x)

result <- sum_max_min(x)
result$Sum_of_observations
result$Minimum_value
result$Maximum_value





###################
##LOOPS
##create object to store output
output <- rep(x = NA, times = 100)
for (i in 1:100) {
cat("iter" = i, "\n")  #print the number of the current iteration
simdata <- rnorm(n = 30, mean = 10, sd = 1)
output[i] <- mean(simdata)
}
mean(output)



###################################################################
##Example to generate samples of 10 observations and compute mean of each to illustrate use of loops - bootstrap example

##specify number of samples
nsims <- 100
##create object to store results and fill it with NA's
mean_data <- rep(NA, nsims)
##display object that will hold means
mean_data

##start loop
for (i in 1:nsims) {  #for indicates that we want to run everything that is enclosed within { } for iteration i;
  ##at iteration i = 1, we generate random sample with 10 observations taken from a normal distribution with mu = 5 and sigma = 3;
  ##then, compute its mean, and store value in mean_data, replacing the first NA with the value;
  ##repeat for iteration i = 2, etc...
mean_data[i] <- mean(rnorm(n = 10, mean = 5, sd = 3))
}
##display results
mean_data

hist(mean_data) #plot a histogram to look at the distribution of the sample means

mean(mean_data) #the mean of the sample means
sd(mean_data)   #the standard deviation of the sample means == STANDARD ERROR OF THE MEAN



######
##functions acting as loops (but more efficiently)
tapply(X = worms$Worm.density, INDEX = worms$Vegetation, FUN = mean)
sapply(X = split(x = worms$Worm.density, f = worms$Vegetation), FUN = mean)





#################################################################
##STATISTICAL ANALYSES
##chi-square
##is proportion same across different size classes?
Freq <- c(124, 176, 180)
chisq.test(Freq, p = c(1/3, 1/3, 1/3))


##test-t for two groups
data(sleep) #patients given 1 of 2 drugs and the increase in sleep relative to control

##t-test
t.test(extra ~ group, mu = 0, data = sleep)
result <- t.test(extra ~ group, mu = 0, data = sleep)
names(result)
result$statistic


##Pearson's correlation
x1 <- rnorm(n = 30, mean = 2, sd = 1)
x2 <- rpois(n = 30, lambda = 5)
cor(x1, x2)
cor.test(x1, x2)

##LINEAR REGRESSION
chocs <- read.table("L:/home/mazerolm/Documents/Stats Consulting/R Intro Workshop/chocs_red.dat",
                    header = TRUE)
mod_reglin <- lm(Price ~ Size, data = chocs)
summary(mod_reglin)

##extracting information from object storing output
##names()
names(mod_reglin)
mod_reglin$coefficients
mod_reglin$residuals

##log-likelihood of model
logLik(mod_reglin)

##influence measures (leverage, influence)
influence.measures(mod_reglin)

##Student residuals
rstudent(mod_reglin)

##plotting diagnostics from object storing output
layout(mat = matrix(1:4, nrow = 2, ncol = 2))
plot(mod_reglin)


##graph of Student residuals vs predicted values
plot(rstudent(mod_reglin) ~ fitted(mod_reglin))
##identify points in graph with mouse clicks
identify(rstudent(mod_reglin) ~ fitted(mod_reglin))



##classic ANOVA, completely randomized design
mod_anova <- aov(Growth ~ Dose + Humidity + Dose:Humidity, data = semis)
summary(mod_anova)



##SAME MODEL FIT AS MULTIPLE LINEAR REGRESSION (now we have estimates)
mod_reglin <- lm(Growth ~ Dose + Humidity + Dose:Humidity, data = semis)
summary(mod_reglin)

##extract information about results object
##names()
names(mod_reglin)
mod_reglin$coefficients

##log-likelihood of model
logLik(mod_reglin)

##plot regression object
plot(mod_reglin)

##graph of Student residuals vs predicted values
plot(rstudent(mod_reglin) ~ fitted(mod_reglin))
##identify points in graph
identify(rstudent(mod_reglin) ~ fitted(mod_reglin))

##influence measures (leverage, influence)
influence.measures(mod_reglin)







##GLM's: Poisson regression
##number of species in quadrats as a function of biomass and pH
species <- read.table("C:/Documents and Settings/mazerolm/Maz folders/Biostat cours Hiver 2007/Species.txt", header = TRUE)
species

##graph
plot(Species ~ Biomass, data = species, ylab = "Number of species", xlab = "Biomass", main = "Number of species vs Biomass")
text(8, 37, labels = "Is this an extreme value?")


##Poisson regression
mod_GLM1 <- glm(Species ~ Biomass + pH, family = poisson, data = species)
summary(mod_GLM1)


##use high as reference level as in SAS
species$pH <- relevel(species$pH, ref = "high")
mod_GLM1 <- glm(Species ~ Biomass + pH, family = poisson, data = species)
summary(mod_GLM1)

plot(mod_GLM1)





##logistic regression
##effect of treatment on pain reduction in patients 6 months after treatment, with age and duration of symptoms before treatment
neural <- read.table("/home/mazerolm/Documents/Biostats cours/Neural.txt", header = TRUE)

##table to summarize frequencies across categorical variables
table(neural$Reduce, neural$Treatment, deparse.level = 2)

mod1<-glm(Reduce ~ Age + Gender, family = binomial(link = logit), data = neural) #adding treatment will stir up problems of perfect classification
summary(mod1)




################################
##PACKAGES

##check which packages are already installed (and where they are saved - useful for Linux and Mac)
library()

##load a package to access its functions, here package 'MASS'
library(MASS)

##unload a package, here package 'MASS'
detach(package:MASS)

##install package from CRAN web site (must be connected to internet)
install.packages()

install.packages(pkgs = "vegan", repos = "http://cran.probability.ca/")

##update packages (good idea to run this function frequently)
update.packages()



worms <- read.table(file =file.choose(),
                    header = TRUE) #must use either \\ or / but not \

#pdf("barplot.pdf")
#jpeg(file="barplotc.jpg", quality=100, type="cairo")
#jpeg(file="barplotx.jpg", quality=100, type="Xlib")
#jpeg(file="barplotq.jpg", quality=100, type="quartz")
#jpeg(file="barplot.jpg", quality=100)
jpeg(file="barplotdpi.jpg", width = 5, height = 5, units="in", res = 1200)
#png(file="barplot.png", width = 480, height = 480)
#png(file="barplot40.png", width = 480, height = 480, res = 45)
#png(file="barplot50.png", width = 2400, height = 2400)
barplot(worms$Worm.density, xlab = "Number of observation", ylab = "Worm density",
        names.arg = c(1:20), cex.axis = 1.2, cex.lab = 1.2, bg = "transparent") #generate barplot and modify x and y axis labels
dev.off()

dev.copy2eps()
dev.copy()


jpeg(file="barplotdpi.jpg", width = 5, height = 5, units="in", res = 1200)
plot(worms$Worm.density ~ worms$Area)
abline(h = 3, v = 5, col = c("red", "blue"))
points(x = 1, y = 4, pch = "+", col = 3, cex = 1.5)
text(x = 2, y = 6, labels = "an area of the graph", col = "magenta")
dev.off()
